// Example scripting engine
// written based on Obs engine
// (c)'01 by SquoQuo
// All code done by Hopper/SquoQuo

#include <stdlib.h>		// for NULL definition
#include "Parameter.h"

#ifndef __ENGINE_FUNCTION
#define __ENGINE_FUNCTION

class Function
{
public:
	char name[128];		// name of the part
	void (*f)(void *tthis, float time, void **p);		// the function pointer itself
	void *tthis;				// myown this-pointer used for the static member functions
	Parameter **parameters;

	// constructor
	Function();

	// destructor
	~Function();

	// the main calling method
	// time is the actual part time (i.e. 0.0 at start of part)
	// pTime is the time that is passed to the parameter calls (goes from 0.0 to 1.0)
	void execute(float time, float pTime);
};

#endif